const path = require('path');
const toArr = require("./utils/utils").toArr;
const log = require("./utils/log");
const file = require("./utils/file");
const level = require("./utils/level");

let err, response;

const update = async (dir, bumpBy) => {
    let name, version;

    log.log(`Reading package remote version... `);
    [err, response] = await level.getRemotePackageVersion(dir);
    if (err) return log.error(`error reading package from ${dir}'s remote`);
    version = response;
    log.log(version);

    log.log(`Reading package local version... `);
    [err, response] = await toArr(file.getPackage(dir));
    if (err) return log.error(`error reading package in ${dir}`);
    name = response.name;
    log.log(`${name}@${response.version}`);

    if (bumpBy) {
        response.version = level.bumpVersion(version, bumpBy);
    } else {
        response.version = version;
    }

    log.log(`Writing version to package... `);
    [err, response] = await toArr(file.writePackage(dir, response));
    if (err) return log.error(`error writing package in ${dir}`);
    log.log(`Done.`);
}

module.exports = {
    update,
}
