const shell = require('./shell');
const file = require('./file');
const toArr = require('./utils').toArr;
const log = require('./log');


const getRemotePackageJson = (cwd) => {
    return shell.run('git show origin/master:package.json', cwd);
}

const getRemotePackageVersion = (cwd) => {
    return toArr(getRemotePackageJson(cwd)
        .then(content => {
            const regex = /"version":\s?"([0-9.]+)",/gm;

            const matches = regex.exec(content);

            if (matches && matches.length > 1) {
                return matches[1];
            }
        }));
}

const bumpVersion = (version, bumpBy) => {
  let parts = version.split('.').map(part => parseInt(part, 10));

  parts[2] += bumpBy;

  return parts.join('.');
}

module.exports = {
    getRemotePackageJson,
    getRemotePackageVersion,
    bumpVersion,
}